// Get ADSL state : hacked together by Kees Lemmens, Aug. 2003

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <syslog.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "main.h"

enum state checkState(void)
{
#define BUFSZ 4096
#define STRSZ 128
#define DEVBASE "eth"
   
   char buf[BUFSZ],*ptr;
   FILE *fp;
   char adsldev[STRSZ], destination[STRSZ], gateway[STRSZ], mask[STRSZ];
   enum state state;
   int flags, i, num;
   
   state = isRed;
   
   /* Check if any of the given ethernet devices is configured */
   if ((fp = fopen("/proc/net/dev","r")) != NULL)
   {
      while (state == isRed && !feof(fp) && fgets(buf,sizeof(buf),fp))
      {
	 if ((ptr = strstr(buf,DEVBASE)) != NULL)
	 {
	    ptr += 3;   /* skip "eth" */
	    
	    sscanf(ptr,"%d",&num);

	    for (i=settings.startdev; i<=settings.enddev; i++)
	    {
	       if (num == i)
	       {
		  state = isYellow;
		  break;
	       }
	    }
	 }
      }
      sprintf(adsldev,"%3s%1.1d",DEVBASE,num);
      fclose(fp);
   }

#ifdef DEBUG
      fprintf(stderr,"Monitored ethernet device : %s\n",adsldev);
#endif
   
   /* Check if any CONFIGURED net device has a default route */
   if (state == isYellow && (fp = fopen("/proc/net/route","r")) != NULL)
   {
      while (!feof(fp) && fgets(buf,sizeof(buf),fp))
      {
	 if(strncmp(buf,adsldev,strlen(adsldev)) == 0)
	 {
	    sscanf(buf,"%*s %20s %20s %d %*s %*s %*s %20s",
		   destination,gateway,&flags,mask);
	    if((flags & 3) == 3)
	    {
#ifdef DEBUG
	       fprintf(stderr,"flags : %d, gateway : %s\n",flags, gateway);
#endif
	       state = isGreen;
	       break;
	    }
	 }
      }      
      fclose(fp);
   }
   
   settings.state = state;
   return state;
}

// This is only for test purposes :
void testmain (int argc, char *argv[])
{
   enum state state;
   
   settings.netup    = NETUPCMD;
   settings.netdown  = NETDOWNCMD;
   settings.label    = LABEL;
   settings.xpos     = settings.ypos = 0;
   settings.startdev = 0;
   settings.enddev   = 0;
   
   while(1)
   {
      state = checkState();
      usleep(500000);
      fprintf(stderr,"state : %d\n",state);
   }
   exit(0);
}

